%% CTVEREC
clc
clear all;
s=[1 2 3 4];
t=[2 3 4 1];
G=digraph(s,t);
plot(G);
P=[1/2 0 0 1/2;
   1/2 1/2 0 0;
   0 1/2 1/2 0;
   0 0 1/2 1/2];
Q=[1/2 0 0 1/2
    1/2 1/2 0 0
    0   1/2 1/2 0
    0   0   1/2 1/2];
alfa=[-2023.2 -826.8 -2535.2 -2535.2]; %parametry alfa
beta=[352.1 257.7 103.7]; %parametry beta
gama=[-8616.8 -7631.0 -3216.7];
epsilon=7.026e-4; 
x1=ones(50,4);
lambda1=ones(50,4);
y1=ones(50,4);
x1(1,:)=[ 100 50 150 150]; %pocatecni podminky pro x
lambda1(1,:)=[ 8.24 8.42 7.63 7.63]; %pocatecni podminky pro lambdu
y1(1,:)=[ 650 -50 600 -150]; %pocatecni podminky pro y
xspodni=[ 100 50 150 150];
xhorni=[400 200 600 600 ];
B=diag([beta(2),beta(3),beta(1),beta(1)]);
for k=2:1:50   
    lambda1(k,:) = (P *  lambda1((k-1),:)') + (epsilon * y1((k-1),:)');
    fi=B*lambda1(k,:)'+alfa';        
    for y=1:1:4      
      if fi(y)>xhorni(y)
        fi(y)=xhorni(y);
        elseif fi(y)<xspodni(y)
        fi(y)=xspodni(y);
      else 
          continue;
      end
    end
    x1(k,:)=fi;
    y1(k,:)=Q * y1((k-1),:)' - (x1(k,:) - x1((k-1),:))';    
    D(k)=sum(x1(k,:));  %celkova energie
    total(k)=1500;
    missin(k)=total(k)-D(k); %chybejici energie
end
%% vykresleni
figure
plot(D);
hold on;
plot(total);
hold on;
plot(missin);
grid on;
title('Pozadovane zatizeni')
xlim([0 50]);
ylim([0 1600]);
xlabel('cas [s]')
ylabel('vykon [MW]')
legend ('celkovy generovany vykon', 'celkovy pozadavek');
figure
plot(lambda1)
xlim([0 50]);
grid on;
legend ('Generator 1', 'Generator 2', 'Generator 3', 'Generator 4', 'Generator 5');
title('Odhadovana inkrementalni cena')
xlabel('cas [s]')
ylabel('cena [$/MWh]')
figure
plot(x1);
grid on;
legend ('Generator 1', 'Generator 2', 'Generator 3', 'Generator 4', 'Generator 5');
title('Vykon generatoru')
xlim([0 50]);
xlabel('cas [s]')
ylabel('vykon [MW]')
figure
plot(y1)
title('Kolektivni odhadovany rozdil vykonu')
xlim([0 50]);
legend ('Generator 1', 'Generator 2', 'Generator 3', 'Generator 4', 'Generator 5');
xlabel('cas [s]')
ylabel('rozdil [MW]')
grid on;

%% LINKA
clc
clear all;
s=[1 2 2 3 3 4];
t=[2 1 3 2 4 3];
G=digraph(s,t);
plot(G);
P=[1/2 1/2 0 0;
    1/3 1/3 1/3 0;
    0 1/3 1/3 1/3
    0 0 1/2 1/2];
Q=[1/2  1/3  0    0
    1/2 1/3  1/3  0
    0   1/3  1/3  1/2
    0   0    1/3   1/2];
alfa=[-2023.2 -826.8 -2535.2 -2535.2]; %parametry alfa
beta=[352.1 257.7 103.7]; %parametry beta
gama=[-8616.8 -7631.0 -3216.7];
epsilon=7.026e-4; 
x1=ones(50,4);
lambda1=ones(50,4);
y1=ones(50,4);
x1(1,:)=[ 100 50 150 150]; %pocatecni podminky pro x
lambda1(1,:)=[ 8.24 8.42 7.63 7.63]; %pocatecni podminky pro lambdu
y1(1,:)=[ 650 -50 600 -150]; %pocatecni podminky pro y
xspodni=[ 100 50 150 150];
xhorni=[400 200 600 600 ];
B=diag([beta(2),beta(3),beta(1),beta(1)]);
for k=2:1:50   
    lambda1(k,:) = (P *  lambda1((k-1),:)') + (epsilon * y1((k-1),:)');
    fi=B*lambda1(k,:)'+alfa';        
    for y=1:1:4      
      if fi(y)>xhorni(y)
        fi(y)=xhorni(y);
        elseif fi(y)<xspodni(y)
        fi(y)=xspodni(y);
      else 
          continue;
      end
    end
    x1(k,:)=fi;
    y1(k,:)=Q * y1((k-1),:)' - (x1(k,:) - x1((k-1),:))';    
    D(k)=sum(x1(k,:));  %celkova energie
    total(k)=1500;
    missin(k)=total(k)-D(k); %chybejici energie
end
%% vykresleni
figure
plot(D);
hold on;
plot(total);
hold on;
plot(missin);
grid on;
title('Pozadovane zatizeni')
xlim([0 50]);
ylim([0 1600]);
xlabel('cas [s]')
ylabel('vykon [MW]')
legend ('celkovy generovany vykon', 'celkovy pozadavek');
figure
plot(lambda1)
xlim([0 50]);
grid on;
legend ('Generator 1', 'Generator 2', 'Generator 3', 'Generator 4', 'Generator 5');
title('Odhadovana inkrementalni cena')
xlabel('cas [s]')
ylabel('cena [$/MWh]')
figure
plot(x1);
grid on;
legend ('Generator 1', 'Generator 2', 'Generator 3', 'Generator 4', 'Generator 5');
title('Vykon generatoru')
xlim([0 50]);
xlabel('cas [s]')
ylabel('vykon [MW]')
figure
plot(y1)
title('Kolektivni odhadovany rozdil vykonu')
xlim([0 50]);
legend ('Generator 1', 'Generator 2', 'Generator 3', 'Generator 4', 'Generator 5');
xlabel('cas [s]')
ylabel('rozdil [MW]')
grid on;
%% 
%% CTVEREC SE STREDEM
clc
clear all;
s=[1 1 1 1 2 2 2 3 3 3 4 4 4 5 5 5];
t=[2 3 4 5 1 3 5 1 2 4 1 3 5 1 2 4];
G=digraph(s,t);
plot(G);
P=[1/5 1/5 1/5 1/5 1/5;
   1/4 1/4 1/4 0 1/4;
   1/4 1/4 1/4 1/4 0;
   1/4 0  1/4 1/4 1/4;
   1/4 1/4 0 1/4 1/4];
Q=[1/5 1/4 1/4 1/4 1/4
   1/5 1/4 1/4  0  1/4
   1/5 1/4 1/4 1/4  0
   1/5  0  1/4 1/4 1/4
   1/5 1/4  0  1/4 1/4];
alfa=[-2023.2 -826.8 -2535.2 -2535.2 -826.8]; %parametry alfa
beta=[352.1 257.7 103.7]; %parametry beta
gama=[-8616.8 -7631.0 -3216.7];
epsilon=7.026*10^(-4)%7.026e-4; %7.026e-10 %7.026e-8 %7.026e-6
x1=ones(50,5);
lambda1=ones(50,5);
y1=ones(50,5);
x1(1,:)=[ 100 50 150 150 50]; %pocatecni podminky pro x
lambda1(1,:)=[ 8.24 8.42 7.63 7.63 8.42]; %pocatecni podminky pro lambdu
y1(1,:)=[ 650 -50 600 -150 -50]; %pocatecni podminky pro y
xspodni=[ 100 50 150 150 50];
xhorni=[400 200 600 600 200];
B=diag([beta(2),beta(3),beta(1),beta(1),beta(3)]);
for k=2:1:50   
    lambda1(k,:) = (P *  lambda1((k-1),:)') + (epsilon * y1((k-1),:)');
    fi=B*lambda1(k,:)'+alfa';        
    for y=1:1:5      
      if fi(y)>xhorni(y)
        fi(y)=xhorni(y);
        elseif fi(y)<xspodni(y)
        fi(y)=xspodni(y);
      else 
          continue;
      end
    end
    x1(k,:)=fi;
    y1(k,:)=Q * y1((k-1),:)' - (x1(k,:) - x1((k-1),:))';    
    D(k)=sum(x1(k,:));  %celkova energie
    total(k)=1500;
    missin(k)=total(k)-D(k); %chybejici energie
end

figure
plot(D);
hold on;
plot(total);
hold on;
plot(missin);
grid on;
title('Pozadovane zatizeni')
xlim([0 50]);
ylim([0 1600]);
xlabel('cas [s]')
ylabel('vykon [MW]')
legend ('celkovy generovany vykon', 'celkovy pozadavek');
figure
plot(lambda1)
xlim([0 50]);
grid on;
legend ('Generator 1', 'Generator 2', 'Generator 3', 'Generator 4', 'Generator 5');
title('Odhadovana inkrementalni cena')
xlabel('cas [s]')
ylabel('cena [$/MWh]')
figure
plot(x1);
grid on;
legend ('Generator 1', 'Generator 2', 'Generator 3', 'Generator 4', 'Generator 5');
title('Vykon generatoru')
xlim([0 50]);
xlabel('cas [s]')
ylabel('vykon [MW]')
figure
plot(y1)
title('Kolektivni odhadovany rozdil vykonu')
xlim([0 50]);
legend ('Generator 1', 'Generator 2', 'Generator 3', 'Generator 4', 'Generator 5');
xlabel('cas [s]')
ylabel('rozdil [MW]')
grid on;
%% 
%% HVEZDA
clc
clear all;
s=[1 2 3 3 3 4 4 5];
t=[3 3 1 2 4 3 5 4];
G=digraph(s,t);
plot(G);
P=[1/2 0 1/2 0 0;
   0 1/2 1/2 0 0;
   1/4 1/4 1/4 1/4 0;
   0 0 1/3 1/3 1/3;
   0 0 0 1/2 1/2];
Q=[1/2   0  1/4  0   0
    0   1/2 1/4  0   0
    1/2 1/2 1/4 1/3  0
    0    0  1/4 1/3 1/2
    0    0   0  1/3 1/2];
alfa=[-2023.2 -826.8 -2535.2 -2535.2 -826.8]; %parametry alfa
beta=[352.1 257.7 103.7]; %parametry beta
gama=[-8616.8 -7631.0 -3216.7];
epsilon=7.026e-4; 
x1=ones(50,5);
lambda1=ones(50,5);
y1=ones(50,5);
x1(1,:)=[ 100 50 150 150 50]; %pocatecni podminky pro x
lambda1(1,:)=[ 8.24 8.42 7.63 7.63 8.42]; %pocatecni podminky pro lambdu
y1(1,:)=[ 650 -50 600 -150 -50]; %pocatecni podminky pro y
xspodni=[ 100 50 150 150 50];
xhorni=[400 200 600 600 200];
B=diag([beta(2),beta(3),beta(1),beta(1),beta(3)]);
for k=2:1:50   
    lambda1(k,:) = (P *  lambda1((k-1),:)') + (epsilon * y1((k-1),:)');
    fi=B*lambda1(k,:)'+alfa';        
    for y=1:1:5      
      if fi(y)>xhorni(y)
        fi(y)=xhorni(y);
        elseif fi(y)<xspodni(y)
        fi(y)=xspodni(y);
      else 
          continue;
      end
    end
    x1(k,:)=fi;
    y1(k,:)=Q * y1((k-1),:)' - (x1(k,:) - x1((k-1),:))';    
    D(k)=sum(x1(k,:));  %celkova energie
    total(k)=1500;
    missin(k)=total(k)-D(k); %chybejici energie
end

figure
plot(D);
hold on;
plot(total);
hold on;
plot(missin);
grid on;
title('Pozadovane zatizeni')
xlim([0 50]);
ylim([0 1600]);
xlabel('cas [s]')
ylabel('vykon [MW]')
legend ('celkovy generovany vykon', 'celkovy pozadavek');
figure
plot(lambda1)
xlim([0 50]);
grid on;
legend ('Generator 1', 'Generator 2', 'Generator 3', 'Generator 4', 'Generator 5');
title('Odhadovana inkrementalni cena')
xlabel('cas [s]')
ylabel('cena [$/MWh]')
figure
plot(x1);
grid on;
legend ('Generator 1', 'Generator 2', 'Generator 3', 'Generator 4', 'Generator 5');
title('Vykon generatoru')
xlim([0 50]);
xlabel('cas [s]')
ylabel('vykon [MW]')
figure
plot(y1)
title('Kolektivni odhadovany rozdil vykonu')
xlim([0 50]);
legend ('Generator 1', 'Generator 2', 'Generator 3', 'Generator 4', 'Generator 5');
xlabel('cas [s]')
ylabel('rozdil [MW]')
grid on;
%% 
%% PETIUHELNIK
clc
clear all;
s=[1 1 2 2 3 3 4 4 5 5];
t=[2 5 3 1 4 2 5 3 1 4];
G=digraph(s,t);

P=[1/3 1/3 0 0 1/3;
   1/3 1/3  1/3   0  0;
   0  1/3  1/3  1/3  0;
   0  0   1/3  1/3 1/3;
    1/3   0   0  1/3 1/3];
Q=[1/3  1/3  0    0   1/3
   1/3  1/3  1/3  0    0
    0   1/3  1/3  1/3  0
    0    0   1/3  1/3 1/3
   1/3   0   0    1/3 1/3];
alfa=[-2023.2 -826.8 -2535.2 -2535.2 -826.8]; %parametry alfa
beta=[352.1 257.7 103.7]; %parametry beta
gama=[-8616.8 -7631.0 -3216.7];
epsilon=7.026e-4; 
x1=ones(50,5);
lambda1=ones(50,5);
y1=ones(50,5);
x1(1,:)=[ 100 50 150 150 50]; %pocatecni podminky pro x
lambda1(1,:)=[ 8.24 8.42 7.63 7.63 8.42]; %pocatecni podminky pro lambdu
y1(1,:)=[ 650 -50 600 -150 -50]; %pocatecni podminky pro y
xspodni=[ 100 50 150 150 50];
xhorni=[400 200 600 600 200];
B=diag([beta(2),beta(3),beta(1),beta(1),beta(3)]);
for k=2:1:50   
    lambda1(k,:) = (P *  lambda1((k-1),:)') + (epsilon * y1((k-1),:)');
    fi=B*lambda1(k,:)'+alfa';        
    for y=1:1:5      
      if fi(y)>xhorni(y)
        fi(y)=xhorni(y);
        elseif fi(y)<xspodni(y)
        fi(y)=xspodni(y);
      else 
          continue;
      end
    end
    x1(k,:)=fi;
    y1(k,:)=Q * y1((k-1),:)' - (x1(k,:) - x1((k-1),:))';    
    D(k)=sum(x1(k,:));  %celkova energie
    total(k)=1500;
    missin(k)=total(k)-D(k); %chybejici energie
end

figure
plot(D);
hold on;
plot(total);
hold on;
plot(missin);
grid on;
title('Pozadovane zatizeni')
xlim([0 50]);
ylim([0 1600]);
xlabel('cas [s]')
ylabel('vykon [MW]')
legend ('celkovy generovany vykon', 'celkovy pozadavek');
figure
plot(lambda1)
xlim([0 50]);
grid on;
legend ('Generator 1', 'Generator 2', 'Generator 3', 'Generator 4', 'Generator 5');
title('Odhadovana inkrementalni cena')
xlabel('cas [s]')
ylabel('cena [$/MWh]')
figure
plot(x1);
grid on;
legend ('Generator 1', 'Generator 2', 'Generator 3', 'Generator 4', 'Generator 5');
title('Vykon generatoru')
xlim([0 50]);
xlabel('cas [s]')
ylabel('vykon [MW]')
figure
plot(y1)
title('Kolektivni odhadovany rozdil vykonu')
xlim([0 50]);
legend ('Generator 1', 'Generator 2', 'Generator 3', 'Generator 4', 'Generator 5');
xlabel('cas [s]')
ylabel('rozdil [MW]')
grid on;
%% 
%% PETIUHELNIK S VAZBAMI
clc
clear all;
s=[ 1 1 1 2 2 3 3 4 4 5 ];
t=[ 4 3 2 4 5 2 5 3 5 1 ];
G=digraph(s,t);
plot(G);
P=[1/3 1/3  0   0  1/3
    0  1/3 1/3 1/3  0
    1/3 0  1/3 1/3  0
    1/2 0   0  1/2  0
     0 1/4 1/4 1/4 1/4];
 Q=[1/3 1/3  0  0   1/2
     0  1/3 1/3 1/4  0
    1/3  0  1/3 1/4  0
    1/3  0   0  1/4  0
     0  1/3 1/3 1/4 1/2];
 alfa=[-2023.2 -826.8 -2535.2 -2535.2 -826.8]; %parametry alfa
beta=[352.1 257.7 103.7]; %parametry beta
gama=[-8616.8 -7631.0 -3216.7];
epsilon=7.026e-4; 
x1=ones(50,5);
lambda1=ones(50,5);
y1=ones(50,5);
x1(1,:)=[ 100 50 150 150 50]; %pocatecni podminky pro x
lambda1(1,:)=[ 8.24 8.42 7.63 7.63 8.42]; %pocatecni podminky pro lambdu
y1(1,:)=[ 650 -50 600 -150 -50]; %pocatecni podminky pro y
xspodni=[ 100 50 150 150 50];
xhorni=[400 200 600 600 200];
B=diag([beta(2),beta(3),beta(1),beta(1),beta(3)]);
for k=2:1:50   
    lambda1(k,:) = (P *  lambda1((k-1),:)') + (epsilon * y1((k-1),:)');
    fi=B*lambda1(k,:)'+alfa';        
    for y=1:1:5      
      if fi(y)>xhorni(y)
        fi(y)=xhorni(y);
        elseif fi(y)<xspodni(y)
        fi(y)=xspodni(y);
      else 
          continue;
      end
    end
    x1(k,:)=fi;
    y1(k,:)=Q * y1((k-1),:)' - (x1(k,:) - x1((k-1),:))';    
    D(k)=sum(x1(k,:));  %celkova energie
    total(k)=1500;
    missin(k)=total(k)-D(k); %chybejici energie
end

figure
plot(D);
hold on;
plot(total);
hold on;
plot(missin);
grid on;
title('Pozadovane zatizeni')
xlim([0 50]);
ylim([0 1600]);
xlabel('cas [s]')
ylabel('vykon [MW]')
legend ('celkovy generovany vykon', 'celkovy pozadavek');
figure
plot(lambda1)
xlim([0 50]);
grid on;
legend ('Generator 1', 'Generator 2', 'Generator 3', 'Generator 4', 'Generator 5');
title('Odhadovana inkrementalni cena')
xlabel('cas [s]')
ylabel('cena [$/MWh]')
figure
plot(x1);
grid on;
legend ('Generator 1', 'Generator 2', 'Generator 3', 'Generator 4', 'Generator 5');
title('Vykon generatoru')
xlim([0 50]);
xlabel('cas [s]')
ylabel('vykon [MW]')
figure
plot(y1)
title('Kolektivni odhadovany rozdil vykonu')
xlim([0 50]);
legend ('Generator 1', 'Generator 2', 'Generator 3', 'Generator 4', 'Generator 5');
xlabel('cas [s]')
ylabel('rozdil [MW]')
grid on;
%%
